'This file simply show how to set file dates and
'times from VB/DOS Applications.  It's nothing
'special.  You will of course, have to modify the
'filenames below to something on your own hard
'disk.  Please note that you must load VB with the
'/L switch prior to using these routines as they call
'DOS interrupts.

'The author makes no warrantys of any kind, including
'but not limited to warrantys of functionality,
'or fitness for a particular purpose.  Use and abuse
'as you wish.  Should you have any comments, send
'them to Lawrence Wimble on Compuserve at 73440,2634
'or through internet mail at SaulsCon@Cyber.Gate.Net.
'Hope it's helpful.


DECLARE FUNCTION GetFileDateTime (filnam AS STRING) AS DOUBLE
DECLARE FUNCTION SetFileDateTime (filnam AS STRING, DateTime AS DOUBLE)

'$INCLUDE: 'VBDOS.BI'

   DIM d AS DOUBLE

   i = GetFileDateTime("D:\DOSPROJ\REPORT.DOC")
   IF i <> 0 THEN
	  PRINT FORMAT$(i, "yyyy-mm-dd  hh:mm a/p")
   END IF
 
   d = DATESERIAL(1995, 2, 18) + TIMESERIAL(15, 21, 0)

   i = SetFileDateTime("D:\DOSPROJ\REPORT.DOC", d)

FUNCTION GetFileDateTime (filnam AS STRING) AS DOUBLE

   DIM RegsX AS RegTypeX
   DIM regs AS RegType
   DIM filename AS STRING
   DIM DosFileHandle AS INTEGER
   DIM dy%  'Year
   DIM dm%  'Month
   DIM dd%  'Day
   DIM th%  'Hour
   DIM tm%  'Minutes
   DIM ts%  'Seconds
   
   filename = filnam + CHR$(0)
   RegsX.ax = &H3D00
   RegsX.ds = SSEG(filename)
   RegsX.DX = SADD(filename)
   INTERRUPTX &H21, RegsX, RegsX   'Open the file

   IF RegsX.flags AND 1 THEN
	  GetFileDate = 0   'Error occurred.
	  EXIT FUNCTION
   ELSE
	  DosFileHandle = RegsX.ax

	  regs.ax = &H5700
	  regs.bx = DosFileHandle
	  INTERRUPT &H21, regs, regs

	  IF regs.flags AND 1 THEN
		 GetFileDate = 0   'Error occurred.
	  ELSE
		 dy% = (regs.DX \ 512) + 1980   'Extract Year
		 dm% = (regs.DX \ 32) AND &HF   'Extract Month
		 dd% = regs.DX AND &H1F         'Extract Day

		 th% = (regs.CX \ 2048)         'Extract Hour
		 tm% = (regs.CX \ 32) AND &H3F  'Extract Minutes
		 ts% = (regs.CX AND &H1F) * 2   'Extract Seconds
		 
		 GetFileDateTime = DATESERIAL(dy%, dm%, dd%) + TIMESERIAL(th%, tm%, ts%)
	  END IF

	  regs.ax = &H3E00
	  regs.bx = DosFileHandle
	  INTERRUPT &H21, regs, regs  'Close the file

   END IF
END FUNCTION

FUNCTION SetFileDateTime (filnam AS STRING, DateTime AS DOUBLE)

   DIM RegsX AS RegTypeX
   DIM regs AS RegType
   DIM filename AS STRING
   DIM l AS LONG
   DIM DosFileHandle AS INTEGER
   DIM dy%  'Year
   DIM dm%  'Month
   DIM dd%  'Day
   DIM th%  'Hour
   DIM tm%  'Minutes
   DIM ts%  'Seconds


   filename = filnam + CHR$(0)
   RegsX.ax = &H3D00
   RegsX.ds = SSEG(filename)
   RegsX.DX = SADD(filename)
   INTERRUPTX &H21, RegsX, RegsX   'Open the file

   IF RegsX.flags AND 1 THEN
	  SetFileDate = 0   'Error occurred.
	  EXIT FUNCTION
   ELSE

	  dy% = YEAR(DateTime) - 1980
	  dm% = MONTH(DateTime)
	  dd% = DAY(DateTime)
	  th% = HOUR(DateTime)
	  tm% = MINUTE(DateTime)
	  ts% = SECOND(DateTime) / 2


	  regs.DX = dd%
	  regs.DX = regs.DX + (32 * dm%)
	  regs.DX = regs.DX + (512 * dy%)

	  regs.CX = ts%
	  regs.CX = regs.CX + (32 * tm%)
	  regs.CX = regs.CX + (2048 * th%)

	  DosFileHandle = RegsX.ax

	  regs.ax = &H5701
	  regs.bx = DosFileHandle
	  INTERRUPT &H21, regs, regs
   END IF

   regs.ax = &H3E00
   regs.bx = DosFileHandle
   INTERRUPT &H21, regs, regs  'Close the file
   
END FUNCTION

